pttn = /^#[ \t]*include[ \t]+"([^"]+)"[ \t]+\/\* ([^ ]+) \*\/[ \t]*$/

raise "usage:#{$0} filename" if ARGV.size != 1
open(ARGV[0]).each { |line|
  line.chomp!
  if m = line.match(pttn) then
    case m[2]
    when "INCLUDE"
      print open("|ruby #{$0} #{m[1]}").read
    end
  else
    printf("%s\n", line)
  end
}
