$stt = /S([0-9][0-9])/
map = Hash.new(nil)

def ent(map, fname, pos, gap)
  open(fname, 'r').each { |line|
    s = line.chomp
    while true
      break if not pos = s.index($stt)
      l = ((pos > 0) ? s.slice(0, pos) : '')
      m = s.slice(pos, 3)
      s = s.slice(pos + 3, s.size - (pos + 3))
      v = m.slice(1, 2).to_i
      u = ((v >= pos) ? (v + gap) : v)
      map[m] = sprintf("S%02d", u) if not map[m]
    end
  }
end

def cnv(map, fname, gap)
  printf("enum {\n")
  max = map.keys.max.slice(1, 2).to_i
  0.upto(max + gap) { |i| printf("  S%02d,\n", i) }
  printf("};\n\n")
  open(fname, 'r').each { |line|
    s = line.chomp
    while true
      break if not pos = s.index($stt)
      l = ((pos > 0) ? s.slice(0, pos) : '')
      m = s.slice(pos, 3)
      s = s.slice(pos + 3, s.size - (pos + 3))
      printf("%s%s", l, map[m])
    end
    printf("%s\n", s)
  }
end
  
if (ARGV.size != 3) \
 || (ARGV[1] !~ /^[0-9]+$/) \
 || (ARGV[2] !~ /^[0-9]+$/) \
 then
  printf("usage:%s filename pos gap\n", $0)
  exit
end

fname = ARGV[0]
pos = ARGV[1].to_i
gap = ARGV[2].to_i
ent(map, fname, pos, gap)
cnv(map, fname, gap)
