require 'jcode'
$KCODE = 's'

def load(fname)
  form = /^S.*$/
  pttn = /case[ \t]+([^ :]+[0-9]+):/
  val = 1
  map = Hash.new(nil)
  open(fname, 'r').read.gsub(/\n/, ' ').scan(pttn) { |r|
    next if r[0] !~ form
    if not map[r[0]] then
      map[r[0]] = val
      val = val + 1
    end
  }
  return map
end

raise "usage:#{$0} filename" if ARGV.size != 1
map = load(ARGV[0])
printf("enum {\n");
map.keys.sort.each { |k| printf("  %s = %d,\n", k, map[k]) }
printf("};\n")
